"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CopyButton = void 0;

var _preact = require("preact");

var _button = require("./button");

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

class CopyButton extends _preact.Component {
  constructor(props) {
    super(props);
    this.state = {
      copying: false,
      copied: false,
      error: false
    };
  }

  render(_ref, {
    copying,
    copied,
    error
  }) {
    let {
      text
    } = _ref,
        rest = _objectWithoutProperties(_ref, ["text"]);

    if (!navigator.clipboard || !navigator.clipboard.writeText) {
      return null;
    }

    return (0, _preact.h)(_button.Button, _extends({
      disabled: copying || copied || rest.disabled,
      onClick: () => {
        this.setState({
          copying: true
        });
        navigator.clipboard.writeText(text).then(() => {
          this.setState({
            copying: false,
            copied: true
          });
          setTimeout(() => {
            this.setState({
              copied: false,
              copying: false
            });
          }, 1000);
        }).catch(() => {
          this.setState({
            copying: false,
            copied: false,
            error: 'failed to copy'
          });
        });
      }
    }, rest), error && 'Failed to copy, try again', !copying && !copied && 'Copy to clipboard', copied && 'Copied!', copying && 'Copying...');
  }

}

exports.CopyButton = CopyButton;