"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

const setupGlobalErrorHandlers = logger => {
  window.addEventListener('error', event => {
    const {
      message,
      filename,
      lineno,
      colno,
      error
    } = event;
    let errorObject = null;

    if (error) {
      errorObject = {
        message: error.message,
        stack: error.stack
      };
    }

    logger.error({
      message,
      filename,
      lineno,
      colno,
      errorObject
    });
  });
  window.addEventListener('unhandledrejection', event => {
    logger.error({
      message: 'unhandledRejection',
      reason: event.reason
    });
  });
};

var _default = setupGlobalErrorHandlers;
exports.default = _default;